Index: drivers/filesystems/btrfs/btrfs.c
===================================================================
--- drivers/filesystems/btrfs/btrfs.c	(révision 75772)
+++ drivers/filesystems/btrfs/btrfs.c	(copie de travail)
@@ -662,15 +817,15 @@
         case FileFsObjectIdInformation:
         {
             FILE_FS_OBJECTID_INFORMATION* ffoi = Irp->AssociatedIrp.SystemBuffer;
-            
+
             TRACE("FileFsObjectIdInformation\n");
-            
+
             RtlCopyMemory(ffoi->ObjectId, &Vcb->superblock.uuid.uuid[0], sizeof(UCHAR) * 16);
             RtlZeroMemory(ffoi->ExtendedInfo, sizeof(ffoi->ExtendedInfo));
-            
+
             BytesCopied = sizeof(FILE_FS_OBJECTID_INFORMATION);
             Status = STATUS_SUCCESS;
-            
+
             break;
         }
 
@@ -677,16 +832,16 @@
         case FileFsSizeInformation:
         {
             FILE_FS_SIZE_INFORMATION* ffsi = Irp->AssociatedIrp.SystemBuffer;
-            
+
             TRACE("FileFsSizeInformation\n");
-            
-            calculate_total_space(Vcb, &ffsi->TotalAllocationUnits.QuadPart, &ffsi->AvailableAllocationUnits.QuadPart);
+
+            calculate_total_space(Vcb, (UINT64*)&ffsi->TotalAllocationUnits.QuadPart, (UINT64*)&ffsi->AvailableAllocationUnits.QuadPart);
             ffsi->SectorsPerAllocationUnit = 1;
             ffsi->BytesPerSector = Vcb->superblock.sector_size;
-            
+
             BytesCopied = sizeof(FILE_FS_SIZE_INFORMATION);
             Status = STATUS_SUCCESS;
-            
+
             break;
         }
 
@@ -696,42 +851,52 @@
             FILE_FS_VOLUME_INFORMATION ffvi;
             BOOL overflow = FALSE;
             ULONG label_len, orig_label_len;
-            
+
             TRACE("FileFsVolumeInformation\n");
             TRACE("max length = %u\n", IrpSp->Parameters.QueryVolume.Length);
-            
+
             ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
-            
-//             orig_label_len = label_len = (ULONG)(wcslen(Vcb->label) * sizeof(WCHAR));
-            RtlUTF8ToUnicodeN(NULL, 0, &label_len, Vcb->superblock.label, (ULONG)strlen(Vcb->superblock.label));
+
+            Status = RtlUTF8ToUnicodeN(NULL, 0, &label_len, Vcb->superblock.label, (ULONG)strlen(Vcb->superblock.label));
+            if (!NT_SUCCESS(Status)) {
+                ERR("RtlUTF8ToUnicodeN returned %08x\n", Status);
+                ExReleaseResourceLite(&Vcb->tree_lock);
+                break;
+            }
+
             orig_label_len = label_len;
-            
+
             if (IrpSp->Parameters.QueryVolume.Length < sizeof(FILE_FS_VOLUME_INFORMATION) - sizeof(WCHAR) + label_len) {
                 if (IrpSp->Parameters.QueryVolume.Length > sizeof(FILE_FS_VOLUME_INFORMATION) - sizeof(WCHAR))
                     label_len = IrpSp->Parameters.QueryVolume.Length - sizeof(FILE_FS_VOLUME_INFORMATION) + sizeof(WCHAR);
                 else
                     label_len = 0;
-                
+
                 overflow = TRUE;
             }
-            
+
             TRACE("label_len = %u\n", label_len);
-            
+
             ffvi.VolumeCreationTime.QuadPart = 0; // FIXME
             ffvi.VolumeSerialNumber = Vcb->superblock.uuid.uuid[12] << 24 | Vcb->superblock.uuid.uuid[13] << 16 | Vcb->superblock.uuid.uuid[14] << 8 | Vcb->superblock.uuid.uuid[15];
             ffvi.VolumeLabelLength = orig_label_len;
             ffvi.SupportsObjects = FALSE;
-            
+
             RtlCopyMemory(data, &ffvi, min(sizeof(FILE_FS_VOLUME_INFORMATION) - sizeof(WCHAR), IrpSp->Parameters.QueryVolume.Length));
-            
+
             if (label_len > 0) {
                 ULONG bytecount;
-                
-//                 RtlCopyMemory(&data->VolumeLabel[0], Vcb->label, label_len);
-                RtlUTF8ToUnicodeN(&data->VolumeLabel[0], label_len, &bytecount, Vcb->superblock.label, (ULONG)strlen(Vcb->superblock.label));
+
+                Status = RtlUTF8ToUnicodeN(&data->VolumeLabel[0], label_len, &bytecount, Vcb->superblock.label, (ULONG)strlen(Vcb->superblock.label));
+                if (!NT_SUCCESS(Status) && Status != STATUS_BUFFER_TOO_SMALL) {
+                    ERR("RtlUTF8ToUnicodeN returned %08x\n", Status);
+                    ExReleaseResourceLite(&Vcb->tree_lock);
+                    break;
+                }
+
                 TRACE("label = %.*S\n", label_len / sizeof(WCHAR), data->VolumeLabel);
             }
-            
+
             ExReleaseResourceLite(&Vcb->tree_lock);
 
             BytesCopied = sizeof(FILE_FS_VOLUME_INFORMATION) - sizeof(WCHAR) + label_len;
@@ -738,13 +903,13 @@
             Status = overflow ? STATUS_BUFFER_OVERFLOW : STATUS_SUCCESS;
             break;
         }
-        
+
 #ifndef __REACTOS__
 #ifdef _MSC_VER // not in mingw yet
         case FileFsSectorSizeInformation:
         {
             FILE_FS_SECTOR_SIZE_INFORMATION* data = Irp->AssociatedIrp.SystemBuffer;
-            
+
             data->LogicalBytesPerSector = Vcb->superblock.sector_size;
             data->PhysicalBytesPerSectorForAtomicity = Vcb->superblock.sector_size;
             data->PhysicalBytesPerSectorForPerformance = Vcb->superblock.sector_size;
@@ -751,14 +916,14 @@
             data->FileSystemEffectivePhysicalBytesPerSectorForAtomicity = Vcb->superblock.sector_size;
             data->ByteOffsetForSectorAlignment = 0;
             data->ByteOffsetForPartitionAlignment = 0;
-            
+
             data->Flags = SSINFO_FLAGS_ALIGNED_DEVICE | SSINFO_FLAGS_PARTITION_ALIGNED_ON_DEVICE;
-            
-            if (Vcb->trim)
+
+            if (Vcb->trim && !Vcb->options.no_trim)
                 data->Flags |= SSINFO_FLAGS_TRIM_ENABLED;
-            
+
             BytesCopied = sizeof(FILE_FS_SECTOR_SIZE_INFORMATION);
-  
+
             break;
         }
 #endif
@@ -769,124 +934,57 @@
             WARN("unknown FsInformationClass %u\n", IrpSp->Parameters.QueryVolume.FsInformationClass);
             break;
     }
-    
-//     if (NT_SUCCESS(Status) && IrpSp->Parameters.QueryVolume.Length < BytesCopied) { // FIXME - should not copy anything if overflow
-//         WARN("overflow: %u < %u\n", IrpSp->Parameters.QueryVolume.Length, BytesCopied);
-//         BytesCopied = IrpSp->Parameters.QueryVolume.Length;
-//         Status = STATUS_BUFFER_OVERFLOW;
-//     }
 
-    Irp->IoStatus.Status = Status;
-    
     if (!NT_SUCCESS(Status) && Status != STATUS_BUFFER_OVERFLOW)
         Irp->IoStatus.Information = 0;
     else
         Irp->IoStatus.Information = BytesCopied;
-    
+
+end:
+    Irp->IoStatus.Status = Status;
+
     IoCompleteRequest( Irp, IO_DISK_INCREMENT );
-    
-exit:
-    if (top_level) 
+
+    if (top_level)
         IoSetTopLevelIrp(NULL);
-    
-    FsRtlExitFileSystem();
-    
+
     TRACE("query volume information returning %08x\n", Status);
 
+    FsRtlExitFileSystem();
+
     return Status;
 }
 
-static NTSTATUS STDCALL read_completion(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID conptr) {
+_Function_class_(IO_COMPLETION_ROUTINE)
+#ifdef __REACTOS__
+static NTSTATUS NTAPI read_completion(_In_ PDEVICE_OBJECT DeviceObject, _In_ PIRP Irp, _In_ PVOID conptr) {
+#else
+static NTSTATUS read_completion(_In_ PDEVICE_OBJECT DeviceObject, _In_ PIRP Irp, _In_ PVOID conptr) {
+#endif
     read_context* context = conptr;
-    
-//     DbgPrint("read_completion\n");
-    
+
+    UNUSED(DeviceObject);
+
     context->iosb = Irp->IoStatus;
     KeSetEvent(&context->Event, 0, FALSE);
-    
-//     return STATUS_SUCCESS;
+
     return STATUS_MORE_PROCESSING_REQUIRED;
 }
 
-// static void test_tree_deletion(device_extension* Vcb) {
-//     KEY searchkey/*, endkey*/;
-//     traverse_ptr tp, next_tp;
-//     root* r;
-//     
-//     searchkey.obj_id = 0x100;
-//     searchkey.obj_type = 0x54;
-//     searchkey.offset = 0xca4ab2f5;
-//     
-// //     endkey.obj_id = 0x100;
-// //     endkey.obj_type = 0x60;
-// //     endkey.offset = 0x15a;
-//     
-//     r = Vcb->roots;
-//     while (r && r->id != 0x102)
-//         r = r->next;
-//     
-//     if (!r) {
-//         ERR("error - could not find root\n");
-//         return;
-//     }
-//     
-//     if (!find_item(Vcb, r, &tp, &searchkey, NULL, FALSE)) {
-//         ERR("error - could not find key\n");
-//         return;
-//     }
-//     
-//     while (TRUE/*keycmp(tp.item->key, endkey) < 1*/) {
-//         tp.item->ignore = TRUE;
-//         add_to_tree_cache(tc, tp.tree);
-//         
-//         if (find_next_item(Vcb, &tp, &next_tp, NULL, FALSE)) {
-//             free_traverse_ptr(&tp);
-//             tp = next_tp;
-//         } else
-//             break;
-//     }
-//     
-//     free_traverse_ptr(&tp);
-// }
-
-// static void test_tree_splitting(device_extension* Vcb) {
-//     int i;
-//     
-//     for (i = 0; i < 1000; i++) {
-//         char* data = ExAllocatePoolWithTag(PagedPool, 4, ALLOC_TAG);
-//         
-//         insert_tree_item(Vcb, Vcb->extent_root, 0, 0xfd, i, data, 4, NULL);
-//     }
-// }
-
-// static void test_dropping_tree(device_extension* Vcb) {
-//     LIST_ENTRY* le = Vcb->roots.Flink;
-//     
-//     while (le != &Vcb->roots) {
-//         root* r = CONTAINING_RECORD(le, root, list_entry);
-//         
-//         if (r->id == 0x101) {
-//             RemoveEntryList(&r->list_entry);
-//             InsertTailList(&Vcb->drop_roots, &r->list_entry);
-//             return;
-//         }
-//         
-//         le = le->Flink;
-//     }
-// }
-
-NTSTATUS create_root(device_extension* Vcb, UINT64 id, root** rootptr, BOOL no_tree, UINT64 offset, PIRP Irp, LIST_ENTRY* rollback) {
+NTSTATUS create_root(_In_ _Requires_exclusive_lock_held_(_Curr_->tree_lock) device_extension* Vcb, _In_ UINT64 id,
+                     _Out_ root** rootptr, _In_ BOOL no_tree, _In_ UINT64 offset, _In_opt_ PIRP Irp) {
+    NTSTATUS Status;
     root* r;
-    tree* t;
+    tree* t = NULL;
     ROOT_ITEM* ri;
     traverse_ptr tp;
-    
+
     r = ExAllocatePoolWithTag(PagedPool, sizeof(root), ALLOC_TAG);
     if (!r) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     r->nonpaged = ExAllocatePoolWithTag(NonPagedPool, sizeof(root_nonpaged), ALLOC_TAG);
     if (!r->nonpaged) {
         ERR("out of memory\n");
@@ -893,7 +991,7 @@
         ExFreePool(r);
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     if (!no_tree) {
         t = ExAllocatePoolWithTag(PagedPool, sizeof(tree), ALLOC_TAG);
         if (!t) {
@@ -902,52 +1000,62 @@
             ExFreePool(r);
             return STATUS_INSUFFICIENT_RESOURCES;
         }
+
+        t->is_unique = TRUE;
+        t->uniqueness_determined = TRUE;
+        t->buf = NULL;
     }
-    
+
     ri = ExAllocatePoolWithTag(PagedPool, sizeof(ROOT_ITEM), ALLOC_TAG);
     if (!ri) {
         ERR("out of memory\n");
-        
-        if (!no_tree)
+
+        if (t)
             ExFreePool(t);
-        
+
         ExFreePool(r->nonpaged);
         ExFreePool(r);
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     r->id = id;
     r->treeholder.address = 0;
     r->treeholder.generation = Vcb->superblock.generation;
-    r->treeholder.tree = no_tree ? NULL : t;
+    r->treeholder.tree = t;
     r->lastinode = 0;
-    r->path.Buffer = NULL;
+    r->dirty = FALSE;
+    r->received = FALSE;
+    r->reserved = NULL;
+    r->parent = 0;
+    r->send_ops = 0;
     RtlZeroMemory(&r->root_item, sizeof(ROOT_ITEM));
     r->root_item.num_references = 1;
     InitializeListHead(&r->fcbs);
-    
+
     RtlCopyMemory(ri, &r->root_item, sizeof(ROOT_ITEM));
-    
+
     // We ask here for a traverse_ptr to the item we're inserting, so we can
     // copy some of the tree's variables
-    
-    if (!insert_tree_item(Vcb, Vcb->root_root, id, TYPE_ROOT_ITEM, offset, ri, sizeof(ROOT_ITEM), &tp, Irp, rollback)) {
-        ERR("insert_tree_item failed\n");
+
+    Status = insert_tree_item(Vcb, Vcb->root_root, id, TYPE_ROOT_ITEM, offset, ri, sizeof(ROOT_ITEM), &tp, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
         ExFreePool(ri);
-        
-        if (!no_tree)
+
+        if (t)
             ExFreePool(t);
-        
+
         ExFreePool(r->nonpaged);
         ExFreePool(r);
-        return STATUS_INTERNAL_ERROR;
+        return Status;
     }
-        
+
     ExInitializeResourceLite(&r->nonpaged->load_tree_lock);
-    
+
     InsertTailList(&Vcb->roots, &r->list_entry);
-    
+
     if (!no_tree) {
+        RtlZeroMemory(&t->header, sizeof(tree_header));
         t->header.fs_uuid = tp.tree->header.fs_uuid;
         t->header.address = 0;
         t->header.flags = HEADER_FLAG_MIXED_BACKREF | 1; // 1 == "written"? Why does the Linux driver record this?
@@ -963,313 +1071,34 @@
         t->parent = NULL;
         t->paritem = NULL;
         t->root = r;
-        
+
         InitializeListHead(&t->itemlist);
-    
+
         t->new_address = 0;
         t->has_new_address = FALSE;
         t->updated_extents = FALSE;
-        
+
         InsertTailList(&Vcb->trees, &t->list_entry);
         t->list_entry_hash.Flink = NULL;
-        
+
         t->write = TRUE;
         Vcb->need_write = TRUE;
     }
-    
+
     *rootptr = r;
 
     return STATUS_SUCCESS;
 }
 
-// static void test_creating_root(device_extension* Vcb) {
-//     NTSTATUS Status;
-//     LIST_ENTRY rollback;
-//     UINT64 id;
-//     root* r;
-//     
-//     InitializeListHead(&rollback);
-//     
-//     if (Vcb->root_root->lastinode == 0)
-//         get_last_inode(Vcb, Vcb->root_root);
-//     
-//     id = Vcb->root_root->lastinode > 0x100 ? (Vcb->root_root->lastinode + 1) : 0x101;
-//     Status = create_root(Vcb, id, &r, &rollback);
-//     
-//     if (!NT_SUCCESS(Status)) {
-//         ERR("create_root returned %08x\n", Status);
-//         do_rollback(Vcb, &rollback);
-//     } else {
-//         Vcb->root_root->lastinode = id;
-//         clear_rollback(&rollback);
-//     }
-// }
-
-// static void test_alloc_chunk(device_extension* Vcb) {
-//     LIST_ENTRY rollback;
-//     chunk* c;
-//     
-//     InitializeListHead(&rollback);
-//     
-//     c = alloc_chunk(Vcb, BLOCK_FLAG_DATA | BLOCK_FLAG_RAID10, &rollback);
-//     if (!c) {
-//         ERR("alloc_chunk failed\n");
-//         do_rollback(Vcb, &rollback);
-//     } else {
-//         clear_rollback(&rollback);
-//     }
-// }
-
-// static void test_space_list(device_extension* Vcb) {
-//     chunk* c;
-//     int i, j;
-//     LIST_ENTRY* le;
-//     
-//     typedef struct {
-//         UINT64 address;
-//         UINT64 length;
-//         BOOL add;
-//     } space_test;
-//     
-//     static const space_test entries[] = {
-//         { 0x1000, 0x1000 },
-//         { 0x3000, 0x2000 },
-//         { 0x6000, 0x1000 },
-//         { 0, 0 }
-//     };
-//     
-//     static const space_test tests[] = {
-//         { 0x0, 0x800, TRUE }, 
-//         { 0x1800, 0x400, TRUE }, 
-//         { 0x800, 0x2000, TRUE }, 
-//         { 0x1000, 0x2000, TRUE }, 
-//         { 0x2000, 0x3800, TRUE }, 
-//         { 0x800, 0x1000, TRUE }, 
-//         { 0x1800, 0x1000, TRUE }, 
-//         { 0x5000, 0x800, TRUE }, 
-//         { 0x5000, 0x1000, TRUE }, 
-//         { 0x7000, 0x1000, TRUE }, 
-//         { 0x8000, 0x1000, TRUE },
-//         { 0x800, 0x800, TRUE }, 
-//         { 0x0, 0x3800, TRUE }, 
-//         { 0x1000, 0x2800, TRUE },
-//         { 0x1000, 0x1000, FALSE },
-//         { 0x800, 0x2000, FALSE },
-//         { 0x0, 0x3800, FALSE },
-//         { 0x2800, 0x1000, FALSE },
-//         { 0x1800, 0x2000, FALSE },
-//         { 0x3800, 0x1000, FALSE },
-//         { 0, 0, FALSE }
-//     };
-//     
-//     c = CONTAINING_RECORD(Vcb->chunks.Flink, chunk, list_entry);
-//     
-//     i = 0;
-//     while (tests[i].length > 0) {
-//         InitializeListHead(&c->space);
-//         InitializeListHead(&c->space_size);
-//         ERR("test %u\n", i);
-//         
-//         j = 0;
-//         while (entries[j].length > 0) {
-//             space* s = ExAllocatePoolWithTag(PagedPool, sizeof(space), ALLOC_TAG);
-//             s->address = entries[j].address;
-//             s->size = entries[j].length;
-//             InsertTailList(&c->space, &s->list_entry);
-//             
-//             order_space_entry(s, &c->space_size);
-//             
-//             j++;
-//         }
-//         
-//         if (tests[i].add)
-//             space_list_add(Vcb, c, FALSE, tests[i].address, tests[i].length, NULL);
-//         else
-//             space_list_subtract(Vcb, c, FALSE, tests[i].address, tests[i].length, NULL);
-//         
-//         le = c->space.Flink;
-//         while (le != &c->space) {
-//             space* s = CONTAINING_RECORD(le, space, list_entry);
-//             
-//             ERR("(%llx,%llx)\n", s->address, s->size);
-//             
-//             le = le->Flink;
-//         }
-//         
-//         ERR("--\n");
-//         
-//         le = c->space_size.Flink;
-//         while (le != &c->space_size) {
-//             space* s = CONTAINING_RECORD(le, space, list_entry_size);
-//             
-//             ERR("(%llx,%llx)\n", s->address, s->size);
-//             
-//             le = le->Flink;
-//         }
-//         
-//         i++;
-//     }
-//     
-//     int3;
-// }
-
-#if 0
-void STDCALL tree_test(void* context) {
-    device_extension* Vcb = context;
+static NTSTATUS set_label(_In_ device_extension* Vcb, _In_ FILE_FS_LABEL_INFORMATION* ffli) {
+    ULONG utf8len;
     NTSTATUS Status;
-    UINT64 id;
-    LARGE_INTEGER due_time, time;
-    KTIMER timer;
-    root* r;
-    LIST_ENTRY rollback;
-    ULONG seed;
-    
-    InitializeListHead(&rollback);
-    
-    KeInitializeTimer(&timer);
-    
-    id = InterlockedIncrement64(&Vcb->root_root->lastinode);
-    Status = create_root(Vcb, id, &r, FALSE, 0, NULL, &rollback);
-    if (!NT_SUCCESS(Status)) {
-        ERR("create_root returned %08x\n");
-        return;
-    }
-    
-    clear_rollback(Vcb, &rollback);
-    
-    due_time.QuadPart = (UINT64)1 * -10000000;
-    
-    KeQueryPerformanceCounter(&time);
-    seed = time.LowPart;
-    
-    while (TRUE) {
-        UINT32 i;
-        
-        FsRtlEnterFileSystem();
-        
-        ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
-        
-        for (i = 0; i < 100; i++) {
-            void* data;
-            ULONG datalen;
-            UINT64 objid, offset;
-            
-            objid = RtlRandomEx(&seed);
-            objid <<= 32;
-            objid |= RtlRandomEx(&seed);
-            
-            offset = RtlRandomEx(&seed);
-            offset <<= 32;
-            offset |= RtlRandomEx(&seed);
-            
-            datalen = 30;
-            data = ExAllocatePoolWithTag(PagedPool, datalen, ALLOC_TAG);
-            
-            if (!insert_tree_item(Vcb, r, objid, 0xfd, offset, data, datalen, NULL, NULL, &rollback)) {
-                ERR("insert_tree_item failed\n");
-            }
-        }
-        
-        for (i = 0; i < 25; i++) {
-            KEY searchkey;
-            traverse_ptr tp;
-            
-            searchkey.obj_id = RtlRandomEx(&seed);
-            searchkey.obj_id <<= 32;
-            searchkey.obj_id |= RtlRandomEx(&seed);
-            
-            searchkey.obj_type = 0xfd;
-            
-            searchkey.offset = RtlRandomEx(&seed);
-            searchkey.offset <<= 32;
-            searchkey.offset |= RtlRandomEx(&seed);
-            
-            Status = find_item(Vcb, r, &tp, &searchkey, FALSE, NULL);
-            if (!NT_SUCCESS(Status)) {
-                ERR("error - find_item returned %08x\n", Status);
-            } else {
-                delete_tree_item(Vcb, &tp, &rollback);
-            }
-        }
-        
-        clear_rollback(Vcb, &rollback);
-        
-        ExReleaseResourceLite(&Vcb->tree_lock);
-        
-        FsRtlExitFileSystem();
-        
-        KeSetTimer(&timer, due_time, NULL);
-        
-        KeWaitForSingleObject(&timer, Executive, KernelMode, FALSE, NULL);
-    }
-}
-#endif
+    ULONG vollen, i;
 
-// static void test_calc_thread(device_extension* Vcb) {
-//     UINT8* data;
-//     ULONG sectors, max_sectors, i, j;
-//     calc_job* cj;
-//     LARGE_INTEGER* sertimes;
-//     LARGE_INTEGER* partimes;
-//     LARGE_INTEGER time1, time2;
-//     
-//     max_sectors = 256;
-//     
-//     sertimes = ExAllocatePoolWithTag(PagedPool, sizeof(LARGE_INTEGER) * max_sectors, ALLOC_TAG);
-//     partimes = ExAllocatePoolWithTag(PagedPool, sizeof(LARGE_INTEGER) * max_sectors, ALLOC_TAG);
-//     RtlZeroMemory(sertimes, sizeof(LARGE_INTEGER) * max_sectors);
-//     RtlZeroMemory(partimes, sizeof(LARGE_INTEGER) * max_sectors);
-//     
-//     for (sectors = 1; sectors <= max_sectors; sectors++) {
-//         data = ExAllocatePoolWithTag(PagedPool, sectors * Vcb->superblock.sector_size, ALLOC_TAG);
-//         RtlZeroMemory(data, sectors * Vcb->superblock.sector_size);
-//         
-//         for (j = 0; j < 100; j++) {
-//             time1 = KeQueryPerformanceCounter(NULL);
-//             
-//             for (i = 0; i < sectors; i++) {
-//                 UINT32 tmp;
-//                 
-//                 tmp = ~calc_crc32c(0xffffffff, data + (i * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
-//             }
-//             
-//             time2 = KeQueryPerformanceCounter(NULL);
-//             
-//             sertimes[sectors - 1].QuadPart += time2.QuadPart - time1.QuadPart;
-//             
-//             time1 = KeQueryPerformanceCounter(NULL);
-//             
-//             add_calc_job(Vcb, data, sectors, &cj);
-//             KeWaitForSingleObject(&cj->event, Executive, KernelMode, FALSE, NULL);
-//             
-//             time2 = KeQueryPerformanceCounter(NULL);
-//             
-//             partimes[sectors - 1].QuadPart += time2.QuadPart - time1.QuadPart;
-//             
-//             free_calc_job(cj);
-//         }
-//         
-//         ExFreePool(data);
-//     }
-//     
-//     for (sectors = 1; sectors <= max_sectors; sectors++) {
-//         ERR("%u sectors: serial %llu, parallel %llu\n", sectors, sertimes[sectors - 1].QuadPart, partimes[sectors - 1].QuadPart);
-//     }
-//     
-//     ExFreePool(partimes);
-//     ExFreePool(sertimes);
-// }
+    TRACE("label = %.*S\n", ffli->VolumeLabelLength / sizeof(WCHAR), ffli->VolumeLabel);
 
-static NTSTATUS STDCALL set_label(device_extension* Vcb, FILE_FS_LABEL_INFORMATION* ffli) {
-    ULONG utf8len;
-    NTSTATUS Status;
-    USHORT vollen, i;
-//     HANDLE h;
-    
-    TRACE("label = %.*S\n", ffli->VolumeLabelLength / sizeof(WCHAR), ffli->VolumeLabel);
-    
     vollen = ffli->VolumeLabelLength;
-    
+
     for (i = 0; i < ffli->VolumeLabelLength / sizeof(WCHAR); i++) {
         if (ffli->VolumeLabel[i] == 0) {
             vollen = i * sizeof(WCHAR);
@@ -1279,7 +1108,7 @@
             goto end;
         }
     }
-    
+
     if (vollen == 0) {
         utf8len = 0;
     } else {
@@ -1286,15 +1115,15 @@
         Status = RtlUnicodeToUTF8N(NULL, 0, &utf8len, ffli->VolumeLabel, vollen);
         if (!NT_SUCCESS(Status))
             goto end;
-        
+
         if (utf8len > MAX_LABEL_SIZE) {
             Status = STATUS_INVALID_VOLUME_LABEL;
             goto end;
         }
     }
-    
+
     ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
-    
+
     if (utf8len > 0) {
         Status = RtlUnicodeToUTF8N((PCHAR)&Vcb->superblock.label, MAX_LABEL_SIZE, &utf8len, ffli->VolumeLabel, vollen);
         if (!NT_SUCCESS(Status))
@@ -1301,23 +1130,13 @@
             goto release;
     } else
         Status = STATUS_SUCCESS;
-    
+
     if (utf8len < MAX_LABEL_SIZE)
         RtlZeroMemory(Vcb->superblock.label + utf8len, MAX_LABEL_SIZE - utf8len);
-    
-//     test_tree_deletion(Vcb); // TESTING
-//     test_tree_splitting(Vcb);
-//     test_dropping_tree(Vcb);
-//     test_creating_root(Vcb);
-//     test_alloc_chunk(Vcb);
-//     test_space_list(Vcb);
-//     test_calc_thread(Vcb);
-    
+
     Vcb->need_write = TRUE;
-    
-//     PsCreateSystemThread(&h, 0, NULL, NULL, NULL, tree_test, Vcb);
-    
-release:  
+
+release:
     ExReleaseResourceLite(&Vcb->tree_lock);
 
 end:
@@ -1326,35 +1145,40 @@
     return Status;
 }
 
-static NTSTATUS STDCALL drv_set_volume_information(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
+_Dispatch_type_(IRP_MJ_SET_VOLUME_INFORMATION)
+_Function_class_(DRIVER_DISPATCH)
+static NTSTATUS drv_set_volume_information(_In_ PDEVICE_OBJECT DeviceObject, _In_ PIRP Irp) {
     PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
     device_extension* Vcb = DeviceObject->DeviceExtension;
     NTSTATUS Status;
     BOOL top_level;
 
-    TRACE("set volume information\n");
-    
     FsRtlEnterFileSystem();
 
+    TRACE("set volume information\n");
+
     top_level = is_top_level(Irp);
-    
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
-        goto exit;
+
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_set_volume_information(DeviceObject, Irp);
+        goto end;
+    } else if (!Vcb || Vcb->type != VCB_TYPE_FS) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
     }
-    
+
     Status = STATUS_NOT_IMPLEMENTED;
-    
+
     if (Vcb->readonly) {
         Status = STATUS_MEDIA_WRITE_PROTECTED;
         goto end;
     }
-    
+
     if (Vcb->removing || Vcb->locked) {
         Status = STATUS_ACCESS_DENIED;
         goto end;
     }
-    
+
     switch (IrpSp->Parameters.SetVolume.FsInformationClass) {
         case FileFsControlInformation:
             FIXME("STUB: FileFsControlInformation\n");
@@ -1362,7 +1186,7 @@
 
         case FileFsLabelInformation:
             TRACE("FileFsLabelInformation\n");
-    
+
             Status = set_label(Vcb, Irp->AssociatedIrp.SystemBuffer);
             break;
 
@@ -1374,88 +1198,103 @@
             WARN("Unrecognized FsInformationClass 0x%x\n", IrpSp->Parameters.SetVolume.FsInformationClass);
             break;
     }
-    
+
 end:
     Irp->IoStatus.Status = Status;
     Irp->IoStatus.Information = 0;
 
+    TRACE("returning %08x\n", Status);
+
     IoCompleteRequest( Irp, IO_NO_INCREMENT );
-    
-exit:
-    if (top_level) 
+
+    if (top_level)
         IoSetTopLevelIrp(NULL);
-    
+
     FsRtlExitFileSystem();
 
     return Status;
 }
 
-static WCHAR* file_desc_fcb(fcb* fcb) {
+static WCHAR* file_desc_fcb(_In_ fcb* fcb) {
     char s[60];
+    NTSTATUS Status;
     UNICODE_STRING us;
     ANSI_STRING as;
-    
+
     if (fcb->debug_desc)
         return fcb->debug_desc;
-    
+
     if (fcb == fcb->Vcb->volume_fcb)
         return L"volume FCB";
-    
+
     fcb->debug_desc = ExAllocatePoolWithTag(PagedPool, 60 * sizeof(WCHAR), ALLOC_TAG);
     if (!fcb->debug_desc)
         return L"(memory error)";
-    
+
     // I know this is pretty hackish...
     // GCC doesn't like %llx in sprintf, and MSVC won't let us use swprintf
     // without the CRT, which breaks drivers.
-    
+
     sprintf(s, "subvol %x, inode %x", (UINT32)fcb->subvol->id, (UINT32)fcb->inode);
-    
+
     as.Buffer = s;
-    as.Length = as.MaximumLength = strlen(s);
-    
+    as.Length = as.MaximumLength = (USHORT)strlen(s);
+
     us.Buffer = fcb->debug_desc;
     us.MaximumLength = 60 * sizeof(WCHAR);
     us.Length = 0;
-    
-    RtlAnsiStringToUnicodeString(&us, &as, FALSE);
-    
+
+    Status = RtlAnsiStringToUnicodeString(&us, &as, FALSE);
+    if (!NT_SUCCESS(Status))
+        return L"(RtlAnsiStringToUnicodeString error)";
+
     us.Buffer[us.Length / sizeof(WCHAR)] = 0;
-    
+
     return fcb->debug_desc;
 }
 
-WCHAR* file_desc_fileref(file_ref* fileref) {
+WCHAR* file_desc_fileref(_In_ file_ref* fileref) {
     NTSTATUS Status;
     UNICODE_STRING fn;
-    
+    ULONG reqlen;
+
     if (fileref->debug_desc)
         return fileref->debug_desc;
-    
-    Status = fileref_get_filename(fileref, &fn, NULL);
+
+    fn.Length = fn.MaximumLength = 0;
+    Status = fileref_get_filename(fileref, &fn, NULL, &reqlen);
+    if (Status != STATUS_BUFFER_OVERFLOW)
+        return L"ERROR";
+
+    if (reqlen > 0xffff - sizeof(WCHAR))
+        return L"(too long)";
+
+    fileref->debug_desc = ExAllocatePoolWithTag(PagedPool, reqlen + sizeof(WCHAR), ALLOC_TAG);
+    if (!fileref->debug_desc)
+        return L"(memory error)";
+
+    fn.Buffer = fileref->debug_desc;
+    fn.Length = 0;
+    fn.MaximumLength = (USHORT)(reqlen + sizeof(WCHAR));
+
+    Status = fileref_get_filename(fileref, &fn, NULL, &reqlen);
     if (!NT_SUCCESS(Status)) {
+        ExFreePool(fileref->debug_desc);
+        fileref->debug_desc = NULL;
         return L"ERROR";
     }
-    
-    fileref->debug_desc = ExAllocatePoolWithTag(PagedPool, fn.Length + sizeof(WCHAR), ALLOC_TAG);
-    if (!fileref->debug_desc) {
-        ExFreePool(fn.Buffer);
-        return L"(memory error)";
-    }
-    
-    RtlCopyMemory(fileref->debug_desc, fn.Buffer, fn.Length);
+
     fileref->debug_desc[fn.Length / sizeof(WCHAR)] = 0;
-    
-    ExFreePool(fn.Buffer);
-    
+
     return fileref->debug_desc;
 }
 
-WCHAR* file_desc(PFILE_OBJECT FileObject) {
+_Ret_z_
+WCHAR* file_desc(_In_ PFILE_OBJECT FileObject) {
     fcb* fcb = FileObject->FsContext;
     ccb* ccb = FileObject->FsContext2;
     file_ref* fileref = ccb ? ccb->fileref : NULL;
-    
+
     if (fileref)
         return file_desc_fileref(fileref);
     else
